Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class CastExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.UnaryExpression
              net.sf.saxon.expr.CastingExpression
                  net.sf.saxon.expr.CastExpression

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, InstructionInfo, Locator

    public class CastExpression

extends CastingExpression

Cast Expression: implements "cast as data-type ( expression )". It also allows an internal cast, which has the same semantics as a user-requested cast, but maps an empty sequence to an empty sequence. This expression class does not handle casting to a union type.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.CastingExpression
`converter, nsResolver`

Fields inherited from class net.sf.saxon.expr.UnaryExpression
`operand`

Fields inherited from class net.sf.saxon.expr.Expression
`EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, WATCH_METHOD`

Constructor Summary
`CastExpression(Expression source, AtomicType target, boolean allowEmpty)` Create a cast expression

Method Summary
`static AtomicValue` | `castStringToQName(CharSequence operand, AtomicType targetType, StaticContext env)` Evaluate the "pseudo-cast" of a string literal to a QName or NOTATION value.
`int` | `computeCardinality()` Get the static cardinality of the expression
`Expression` | `copy()` Copy an expression.
`boolean` | `equals(Object other)` Is this expression the same as another expression?
`Item` | `evaluateItem(XPathContext context)` Evaluate the expression
`void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`IntegerValue[]` | `getIntegerBounds()` For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis.
`ItemType` | `getItemType(TypeHierarchy th)` Get the static type of the expression
`int` | `hashCode()` get HashCode for comparing two expressions.
`Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`protected Expression` | `preEvaluate()` Perform early (compile-time) evaluation
`String` | `toString()` The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath.
`Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.CastingExpression
`allowsEmpty, computeSpecialProperties, getConverter, getNamespaceResolver, getTargetPrimitiveType, getTargetType, isOperandIsStringLiteral, setAllowEmpty, setNamespaceResolver, setOperandIsStringLiteral, setTargetType, simplify`

Methods inherited from class net.sf.saxon.expr.UnaryExpression
`displayOperator, getBaseExpression, iterateSubExpressions, promote, replaceSubExpression`

Methods inherited from class net.sf.saxon.expr.Expression
`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getExpressionName, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterate, iterateEvents, iterateSameFocusSubExpressions, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### CastExpression

    public CastExpression(Expression source,
                          AtomicType target,
                          boolean allowEmpty)

  Create a cast expression

  Parameters:
    `source` - expression giving the value to be converted
    `target` - the type to which the value is to be converted
    `allowEmpty` - true if the expression allows an empty sequence as input, producing an empty sequence as output. If false, an empty sequence is a type error.

Method Detail

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ExpressionVisitor.ContextItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `UnaryExpression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ExpressionVisitor.ContextItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `UnaryExpression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### preEvaluate

    protected Expression preEvaluate()
                              throws XPathException

  Perform early (compile-time) evaluation

  Throws:
    `XPathException`

### computeCardinality

    public int computeCardinality()

  Get the static cardinality of the expression

  Overrides:
    `computeCardinality` in class `UnaryExpression`
  Returns:
    the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the static type of the expression

  Overrides:
    `getItemType` in class `UnaryExpression`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the item type of the items in the result sequence, insofar as this is known statically.

### getIntegerBounds

    public IntegerValue[] getIntegerBounds()

  For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis. The default implementation returns null, meaning "unknown" or "not applicable". Other implementations return an array of two IntegerValue objects, representing the lower and upper bounds respectively. The values UNBOUNDED_LOWER and UNBOUNDED_UPPER are used by convention to indicate that the value may be arbitrarily large. The values MAX_STRING_LENGTH and MAX_SEQUENCE_LENGTH are used to indicate values limited by the size of a string or the size of a sequence.

  Overrides:
    `getIntegerBounds` in class `Expression`
  Returns:
    the lower and upper bounds of integer values in the result, or null to indicate unknown or not applicable.

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate the expression

  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### equals

    public boolean equals(Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `UnaryExpression`

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions. Note that this hashcode gives the same result for (A op B) and for (B op A), whether or not the operator is commutative.

  Overrides:
    `hashCode` in class `UnaryExpression`

### toString

    public String toString()

  The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath. In the case of XSLT instructions, the toString() method gives an abstracted view of the syntax

  Overrides:
    `toString` in class `UnaryExpression`
  Returns:
    a representation of the expression as a string

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Overrides:
    `explain` in class `UnaryExpression`
  Parameters:
    `out` - the expression presenter used to display the structure

### castStringToQName

    public static AtomicValue castStringToQName(CharSequence operand,
                                                AtomicType targetType,
                                                StaticContext env)
                                         throws XPathException

  Evaluate the "pseudo-cast" of a string literal to a QName or NOTATION value. This can only happen at compile time

  Parameters:
    `operand` - the value to be converted
    `targetType` - the type to which it is to be converted
    `env` - the static context
  Returns:
    the QName or NOTATION value that results from casting the string to a QName. This will either be a QNameValue or a derived AtomicValue derived from QName or NOTATION
  Throws:
    `XPathException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.